
# coding: utf-8

# In[12]:

#modules 
get_ipython().magic('matplotlib inline')
import scipy
import numpy as np
import datetime 
import statistics
import glob
import xarray as xr
import time
import math
import warnings
import os
import pandas as pd 
import matplotlib.pyplot as plt 


from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)


# In[1]:



filename = '/home/hiault/Python_stage/Data/ACE_FTS_V5/nc/ACEFTS_L2_v5p0_CHF3.nc'

ds = xr.open_dataset(filename)
df = ds.to_dataframe()
#df.to_csv('ACEFTS_L2_v5p0_CHF3.csv')

#filename2 = '/home/fhiault/Bureau/ACE_FTS_v5/ACEFTS_L2_v5p0_CHF3.csv'
filename2 = '/home/hiault/Python_stage/Data/ACE_FTS_V5/ACEFTS_L2_v5p0_CHF3.csv'
df2 = pd.read_csv(filename2, sep=',',skipinitialspace=True, header=0) #le dataframe issu du csv


# In[ ]:

#Switzerland area : df3 
# lat : 40:60
# long : -5:15

lat1 = 40
lat2 = 60
long1 = -5 
long2 = 15 
err_value = -999
err_value2 = -888
ppt = 10**12



df3=df2.loc[(df2['latitude'] >= lat1) & (df2['latitude'] <= lat2) & (df2['longitude'] >= long1)
            & (df2['longitude'] <= long2) & (df2['CHF3_error'] != err_value) & (df2['CHF3_error'] != err_value2)]



datetime = pd.to_datetime(df3[['year','month','day']]) # création d'un vecteur "datetime" regroupant yyyy-mm-dd
df3['datetime'] = datetime #ajout de la colonne "datetime" dans le dataframe 
df3 = df3.set_index('datetime',drop=True) #je place la colonne créee en index 


#création new column valeur en ppt for CHF3
df3['CHF3_ppt'] = df3['CHF3'] * ppt 
df3.to_csv('Switzerland_area.csv')


# In[ ]:

#Ireland area : df4
# lat : 40:60
# long : -25:5

lat3 = 40
lat4 = 60
long3 = -25 
long4 = 5 
err_value3 = -999
err_value4 = -888
ppt = 10**12

df4=df2.loc[(df2['latitude'] >= lat3) & (df2['latitude'] <= lat4) & (df2['longitude'] >= long3)
            & (df2['longitude'] <= long4) & (df2['CHF3_error'] != err_value3) & (df2['CHF3_error'] != err_value4)]

datetime = pd.to_datetime(df4[['year','month','day']]) # création d'un vecteur "datetime" regroupant yyyy-mm-dd
df4['datetime'] = datetime #ajout de la colonne "datetime" dans le dataframe 
df4 = df4.set_index('datetime',drop=True) #je place la colonne créee en index 

#création new column valeur en ppt for CHF3
df4['CHF3_ppt'] = df4['CHF3'] * ppt 
df4.to_csv('Ireland_area.csv')


# ### Création dataframe avec lim entre 0 et 60 ppt

# In[ ]:

#filename_test = r'C:\Users\ACER\Desktop\ACE_FTS_V5_test\Ireland_area_modified.csv'
filename_test_IRA = '/home/fhiault/Bureau/ACE_FTS_v5/Ireland_area_modified.csv'
filename_test_CH = '/home/fhiault/Bureau/ACE_FTS_v5/Switzerland_area_modified.csv'

df_test_IRA = pd.read_csv(filename_test_IRA, sep=';',skipinitialspace=True, header=0) 
df_test_CH = pd.read_csv(filename_test_CH, sep=';',skipinitialspace=True, header=0)

#new dataframe with new limit of CHF3_ppt (0:60)

df_test_IRA_nl=df_test_IRA.loc[(df_test_IRA['CHF3_ppt'] >= 0) & (df_test_IRA['CHF3_ppt'] <= 60)]
df_test_IRA_nl.to_csv('Ireland_area_nl_concentration.csv')

df_test_CH_nl=df_test_CH.loc[(df_test_CH['CHF3_ppt'] >= 0) & (df_test_CH['CHF3_ppt'] <= 60)]
df_test_CH_nl.to_csv('Switzerland_area_nl_concentration.csv')


# ### Visualisation des données non filtrées

# In[9]:

#filename1 = r'C:\Users\ACER\Desktop\Stage\Stage\Data\ACE_FTS_V5\csv\temp_CH.csv'
#filename2 = r'C:\Users\ACER\Desktop\Stage\Stage\Data\ACE_FTS_V5\csv\temp_IRA.csv'


filename1 = '/home/hiault/Python_stage/Data/ACE_FTS_V5/csv/temp_CH.csv'
filename2 = '/home/hiault/Python_stage/Data/ACE_FTS_V5/csv/temp_IRA.csv'

#output = r'C:\Users\ACER\Desktop\Stage\Stage\output\' 
output = '/home/hiault/Python_stage/out/'


# In[10]:

df1 = pd.read_csv(filename1, sep=';', header=0) #Header = 0 -> si il y a déjà des noms de colonnes 
df2 = pd.read_csv(filename2, sep=';', header=0)


df1 = df1.set_index('datetime', drop=True)
df2 = df2.set_index('datetime', drop=True)


#df1
#df2


#création des axes : 

axe_t1 = df1['YearFraction']
axe_t2 = df2['Yearfraction']

daily_mean1 = df1['CHF3_ppt']
daily_mean2 = df2['CHF3_ppt']

tendance1 = df1['Tendance ']
tendance2 = df2['Tendance']

borne_inf1 = df1['borne_inf']
borne_inf2= df2['borne_inf']

borne_sup1 = df1['borne_sup']
borne_sup2 = df2['borne_sup']


# #### visualisation df1 

# In[34]:

import matplotlib.pyplot as plt
import numpy as np

# Define colors for better visibility of the interval
trend_color = '#1f77b4'       # Dark blue color for trend line
interval_color = '#aec7e8'    # Light blue color for interval zone
data_color = '#b2df8a'        # Green color for data points

fig, ax = plt.subplots(figsize=(16, 9))

# Trend line
ax.plot(axe_t1, tendance1, color=trend_color, linewidth=3, label='Trend')



# Data points
ax.scatter(axe_t1, daily_mean1, color=data_color, s=20, label='Daily means')



# Interval bands - Filling with light blue color
ax.fill_between(axe_t1, borne_sup1, borne_inf1, color=interval_color, alpha=0.5,
                label='Trend ± 1 standard deviation')

ax.set_title('ACE-FTS Data in Switzerland Area\nTrend with Interval Bands', fontsize=24)
ax.set_xlabel('Year', fontsize=18)
ax.set_ylabel('VMR (ppt)', fontsize=18)

ax.legend(fontsize=16, loc='best')

ax.xaxis.set_major_locator(MultipleLocator(2))
ax.xaxis.set_minor_locator(MultipleLocator(1))
ax.yaxis.set_major_locator(MultipleLocator(10))
ax.yaxis.set_minor_locator(MultipleLocator(5))

# Set tick parameters
ax.tick_params(axis='both', which='major', direction='inout', length=8, width=1.5, labelsize=16)
ax.tick_params(axis='both', which='minor', direction='inout', length=4, width=1.5, labelsize=16)

# Increase title font size
plt.rc('font', **{'size': '20'})

plt.tight_layout()
plt.show()
#fig.savefig( output + 'Filtring_data_Switzerland_area.pdf', bbox_inches='tight', dpi=300)



# #### df2

# In[35]:

import matplotlib.pyplot as plt
import numpy as np

# Define colors for better visibility of the interval
trend_color = '#1f77b4'       # Dark blue color for trend line
interval_color = '#aec7e8'    # Light blue color for interval zone
data_color = '#b2df8a'        # Green color for data points

fig, ax = plt.subplots(figsize=(16, 9))

# Trend line
ax.plot(axe_t2, tendance2, color=trend_color, linewidth=3, label='Trend')



# Data points
ax.scatter(axe_t2, daily_mean2, color=data_color, s=20, label='Daily means')



# Interval bands - Filling with light blue color
ax.fill_between(axe_t2, borne_sup2, borne_inf2, color=interval_color, alpha=0.5,
                label='Trend ± 1 standard deviation')

ax.set_title('ACE-FTS Data in Ireland Area\nTrend with Interval Bands', fontsize=24)
ax.set_xlabel('Year', fontsize=18)
ax.set_ylabel('VMR (ppt)', fontsize=18)

ax.legend(fontsize=16, loc='best')

ax.xaxis.set_major_locator(MultipleLocator(2))
ax.xaxis.set_minor_locator(MultipleLocator(1))
ax.yaxis.set_major_locator(MultipleLocator(10))
ax.yaxis.set_minor_locator(MultipleLocator(5))

# Set tick parameters
ax.tick_params(axis='both', which='major', direction='inout', length=8, width=1.5, labelsize=16)
ax.tick_params(axis='both', which='minor', direction='inout', length=4, width=1.5, labelsize=16)

# Increase title font size
plt.rc('font', **{'size': '20'})

plt.tight_layout()
plt.show()
#fig.savefig( output + 'Filtring_data_Ireland_area.pdf', bbox_inches='tight', dpi=300)



# ### filtrage des données 

# In[ ]:

chemin_temp1 = r'C:\Users\ACER\Desktop\ACE_FTS_V5_test\temp_IRA.csv'
chemin_temp2 = r'C:\Users\ACER\Desktop\ACE_FTS_V5_test\temp_CH.csv'

df_temp_IRA = pd.read_csv(chemin_temp1, sep=';',skipinitialspace=True, header=0) 
df_temp_CH = pd.read_csv(chemin_temp2, sep=';',skipinitialspace=True, header=0) 

df_temp2_IRA=df_temp_IRA.loc[(df_temp_IRA['filtrage'] == 1)] 
df_temp2_CH=df_temp_CH.loc[(df_temp_CH['filtrage'] == 1)]    

df_temp2_IRA.to_csv('data_filtered_IRA_ACE_FTS.csv')
df_temp2_CH.to_csv('data_filtered_CH_ACE_FTS.csv')

#rajout manuel via excel des erreurs en ppt pour concentration CHF3 

